var __reflect = (this && this.__reflect) || function (p, c, t) {
    p.__class__ = c, t ? t.push(c) : t = [c], p.__types__ = p.__types__ ? t.concat(p.__types__) : t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * 游戏主要管理器
 */
var GameMgr = (function () {
    function GameMgr() {
        Lang.instance.register();
        EosMgr.instance.register();
    }
    Object.defineProperty(GameMgr, "instance", {
        get: function () {
            if (!this._instance) {
                this._instance = new GameMgr();
            }
            return this._instance;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GameMgr.prototype, "main", {
        get: function () {
            return this._main;
        },
        enumerable: true,
        configurable: true
    });
    GameMgr.prototype.setMain = function (main) {
        this._main = main;
    };
    Object.defineProperty(GameMgr.prototype, "uiController", {
        get: function () { return this._uiCtrl; },
        enumerable: true,
        configurable: true
    });
    GameMgr.prototype.runGame = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // 将ui控制器添加到舞台中
                        this._uiCtrl = UIController.instance;
                        this._main.stage.addChild(this._uiCtrl);
                        return [4 /*yield*/, this.preload()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.loadResource()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 预加载部分资源
     */
    GameMgr.prototype.preload = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('preload');
                        return [4 /*yield*/, RES.loadConfig("default.res.json", 'resource/')];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, RES.loadGroup("preload")];
                    case 2:
                        _a.sent();
                        // 皮肤方案
                        return [4 /*yield*/, this.loadTheme()];
                    case 3:
                        // 皮肤方案
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 加载资源
     */
    GameMgr.prototype.loadResource = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('loadResource');
                        // 加载其他资源组
                        return [4 /*yield*/, RES.loadGroup("audio")];
                    case 1:
                        // 加载其他资源组
                        _a.sent();
                        if (!GAME_ISMOBILE) return [3 /*break*/, 3];
                        return [4 /*yield*/, RES.loadGroup("skin_h5")];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, RES.loadGroup("skin_pc")];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5:
                        this.createGameScene();
                        return [2 /*return*/];
                }
            });
        });
    };
    GameMgr.prototype.loadTheme = function () {
        var _this = this;
        console.log('loadTheme start');
        return new Promise(function (resolve, reject) {
            // load skin theme configuration file, you can manually modify the file. And replace the default skin.
            //加载皮肤主题配置文件,可以手动修改这个文件。替换默认皮肤。
            var theme = new eui.Theme("resource/default.thm.json", _this._main.stage);
            theme.addEventListener(eui.UIEvent.COMPLETE, function () {
                resolve();
            }, _this);
        });
    };
    /**
     * 创建游戏场景
     * Create a game scene
     */
    GameMgr.prototype.createGameScene = function () {
        console.log("进入游戏场景");
        // 移除loading界面
        if (this.loadingView) {
            this.loadingView = undefined;
        }
        this.index = Index.instance;
        SocketMgr.instance.openSocket();
        // setTimeout(function () {
        // 	AudiosMgr.instance.playBgm();
        // }, 300);
    };
    /**
     * 添加事件监听
     */
    GameMgr.prototype.addEventListener = function (type, listener, thisObject, useCapture, priority) {
        return this._main.addEventListener(type, listener, thisObject, useCapture, priority);
    };
    /**
     * 移除事件监听
     */
    GameMgr.prototype.removeEventListener = function (type, listener, thisObject, useCapture) {
        this._main.removeEventListener(type, listener, thisObject, useCapture);
    };
    /**
     * 分派事件
     */
    GameMgr.prototype.dispatchEvent = function (event) {
        return this._main.dispatchEvent(event);
    };
    /**
     * 派发一个指定参数的事件。
     * @param type {string} 事件类型
     * @param bubbles {boolean} 确定 Event 对象是否参与事件流的冒泡阶段。默认值为 false。
     * @param data {any} 事件data
     * @param cancelable {boolean} 确定是否可以取消 Event 对象。默认值为 false。
     */
    GameMgr.prototype.dispatchEventWith = function (type, bubbles, data, cancelable) {
        return this._main.dispatchEventWith(type, bubbles, data, cancelable);
    };
    return GameMgr;
}());
__reflect(GameMgr.prototype, "GameMgr");
