var __reflect = (this && this.__reflect) || function (p, c, t) {
    p.__class__ = c, t ? t.push(c) : t = [c], p.__types__ = p.__types__ ? t.concat(p.__types__) : t;
};
var Lang = (function () {
    function Lang() {
        this.langTypes = [LANG_CN, LANG_EN];
        this.langEnum = 0;
        this.eventDispatcher = new egret.EventDispatcher();
    }
    Lang.prototype.lang = function () {
        return this.langTypes[this.langEnum];
    };
    Object.defineProperty(Lang, "instance", {
        get: function () {
            if (!this._instance) {
                this._instance = new Lang();
            }
            return this._instance;
        },
        enumerable: true,
        configurable: true
    });
    Lang.prototype.register = function () {
        window.addEventListener("message", this.langChange.bind(this), false);
    };
    Lang.prototype.langChange = function (ev) {
        console.log("message:", ev);
        this.langEnum = ev.data.lang;
        this.dispatchEvent(new egret.Event(SocketEvent.LANG_CHANGE, false, false));
    };
    Lang.prototype.dispatchEvent = function (event) {
        this.eventDispatcher.dispatchEvent(event);
    };
    /**
     * 添加事件监听
     */
    Lang.prototype.addEventListener = function (type, listener, thisObject, useCapture, priority) {
        this.eventDispatcher.addEventListener(type, listener, thisObject, useCapture, priority);
    };
    /**
     * 移除事件监听
     */
    Lang.prototype.removeEventListener = function (type, listener, thisObject, useCapture) {
        this.eventDispatcher.removeEventListener(type, listener, thisObject, useCapture);
    };
    return Lang;
}());
__reflect(Lang.prototype, "Lang");
