var __reflect = (this && this.__reflect) || function (p, c, t) {
    p.__class__ = c, t ? t.push(c) : t = [c], p.__types__ = p.__types__ ? t.concat(p.__types__) : t;
};
var AudiosMgr = (function () {
    function AudiosMgr() {
        this.audiosRes = {};
        this.bgmAllow = false;
        this.bgmPosition = 0;
    }
    Object.defineProperty(AudiosMgr, "instance", {
        get: function () {
            if (!this._instance) {
                this._instance = new AudiosMgr();
            }
            return this._instance;
        },
        enumerable: true,
        configurable: true
    });
    /**获取sound资源 */
    AudiosMgr.prototype.getAudioSource = function (soundName) {
        this.audiosRes[soundName] = this.audiosRes[soundName] || RES.getRes(soundName);
        return this.audiosRes[soundName];
    };
    AudiosMgr.prototype.playSound = function (soundName, startTime, loops) {
        if (startTime === void 0) { startTime = 0; }
        if (loops === void 0) { loops = 1; }
        return this.getAudioSource(soundName).play(startTime, loops);
    };
    AudiosMgr.prototype.setBgmAllow = function (allow) {
        this.bgmAllow = allow;
    };
    AudiosMgr.prototype.playBgm = function () {
        if (this.bgm)
            return;
        try {
            console.log('play bgm');
            this.bgm = this.playSound('bgm_mp3', this.bgmPosition, 0);
        }
        catch (e) {
            console.error('bgm play error:', e);
        }
        Index.instance.setMusicToggle(true);
    };
    AudiosMgr.prototype.stopBgm = function () {
        if (this.bgm) {
            console.log('stop bgm');
            this.bgmPosition = this.bgm.position;
            this.bgm.stop();
            this.bgm = null;
            Index.instance.setMusicToggle(false);
        }
    };
    AudiosMgr.prototype.playButtonClick = function () {
        return this.playSound('button-click_mp3');
    };
    return AudiosMgr;
}());
__reflect(AudiosMgr.prototype, "AudiosMgr");
