var __reflect = (this && this.__reflect) || function (p, c, t) {
    p.__class__ = c, t ? t.push(c) : t = [c], p.__types__ = p.__types__ ? t.concat(p.__types__) : t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var EosMgr = (function () {
    function EosMgr() {
        this.scatter = null;
        this.identity = null;
        this.eos = null;
    }
    Object.defineProperty(EosMgr, "instance", {
        get: function () {
            if (!this._instance) {
                this._instance = new EosMgr();
            }
            return this._instance;
        },
        enumerable: true,
        configurable: true
    });
    EosMgr.prototype.register = function () {
        this.scatterLoad();
        top.addEventListener('scatterLoaded', this.scatterLoad);
    };
    EosMgr.prototype.login = function () {
        return __awaiter(this, void 0, void 0, function () {
            var identity, accounts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.scatter) {
                            console.log('installScatter');
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.scatter.getIdentity({ accounts: [this.getNetwork()] })];
                    case 1:
                        identity = _a.sent();
                        if (identity) {
                            accounts = identity.accounts.find(function (x) { return x.blockchain === 'eos'; });
                            UserMgr.instance.setAccount(accounts);
                            this.getEos(this.scatter);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    EosMgr.prototype.scatterLoad = function () {
        return __awaiter(this, void 0, void 0, function () {
            var scatter, accounts;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!top['scatter']) {
                            return [2 /*return*/];
                        }
                        scatter = top['scatter'];
                        return [4 /*yield*/, this.getIdentity(scatter)];
                    case 1:
                        _a.sent();
                        if (this.identity) {
                            accounts = this.identity.accounts.find(function (x) { return x.blockchain === 'eos'; });
                            UserMgr.instance.setAccount(accounts);
                            this.getEos(scatter);
                        }
                        this.scatter = scatter;
                        top['scatter'] = null;
                        top.removeEventListener('scatterLoaded', this.scatterLoad);
                        return [2 /*return*/];
                }
            });
        });
    };
    EosMgr.prototype.getIdentity = function (scatter) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        _a = this;
                        return [4 /*yield*/, scatter.getIdentity({ accounts: [this.getNetwork()] })];
                    case 1:
                        _a.identity = _b.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _b.sent();
                        if (err_1.isError) {
                            return [2 /*return*/];
                        }
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    EosMgr.prototype.getEos = function (scatter) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.eos = scatter.eos(this.getNetwork(), Eos, {});
                return [2 /*return*/];
            });
        });
    };
    EosMgr.prototype.getBalance = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.identity) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.eos.getCurrencyBalance('eosio.token', this.identity.account.name, 'EOS')];
                    case 1: return [2 /*return*/, _a.sent()];
                    case 2: return [2 /*return*/, 0];
                }
            });
        });
    };
    EosMgr.prototype.getNewPermissions = function (accountName) {
        return __awaiter(this, void 0, void 0, function () {
            var account, perms;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.eos) {
                            console.log('not login');
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.eos.getAccount(accountName)];
                    case 1:
                        account = _a.sent();
                        perms = JSON.parse(JSON.stringify(account.permissions));
                        return [2 /*return*/, perms];
                }
            });
        });
    };
    // EOS配置
    EosMgr.prototype.getNetwork = function () {
        if (/^test-|\.webdev2\./.test(location.host) || location.host == '0.0.0.0:8080' || location.host.indexOf('172.16.14') >= 0) {
            return {
                protocol: 'http',
                blockchain: 'eos',
                port: '7777',
                host: '61.160.36.19',
                chainId: 'cf057bbfb72640471fd910bcb67639c22df9f92470936cddc1ade0e2f2e7dc4f'
            };
        }
        else {
            return {
                protocol: 'https',
                blockchain: 'eos',
                port: '443',
                host: 'nodes.get-scatter.com',
                chainId: 'aca376f206b8fc25a6ed44dbdc66547c36c6c33e3a119ffbeaef943642f0e906'
            };
        }
    };
    // 下注
    EosMgr.prototype.transfer = function (name, toAccount, amount, memo, options) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.eos.transfer(name, toAccount, amount + ' EOS', memo, options).then(function (trx) {
                console.log('confirmBet succ');
                resolve(trx);
            }).catch(function (msg) {
                console.error('confirmBet error:', msg);
                reject(msg);
            });
        });
    };
    return EosMgr;
}());
__reflect(EosMgr.prototype, "EosMgr");
