var __reflect = (this && this.__reflect) || function (p, c, t) {
    p.__class__ = c, t ? t.push(c) : t = [c], p.__types__ = p.__types__ ? t.concat(p.__types__) : t;
};
var __extends = this && this.__extends || function __extends(t, e) { 
 function r() { 
 this.constructor = t;
}
for (var i in e) e.hasOwnProperty(i) && (t[i] = e[i]);
r.prototype = e.prototype, t.prototype = new r();
};
/**
 * UI根节点
 */
var UIController = (function (_super) {
    __extends(UIController, _super);
    function UIController() {
        var _this = _super.call(this) || this;
        //注入自定义的素材解析器
        egret.registerImplementation("eui.IAssetAdapter", new AssetAdapter());
        egret.registerImplementation("eui.IThemeAdapter", new ThemeAdapter());
        _this._innerLayer = new eui.UILayer();
        _this._innerLayer.touchChildren = true;
        _this._alertLayer = new eui.UILayer();
        _this._alertLayer.touchThrough = true;
        _this._barLayer = new eui.UILayer();
        _this._barLayer.touchThrough = true;
        _this._mainLayer = new eui.UILayer();
        _this.addChild(_this._innerLayer);
        _this.addChild(_this._mainLayer);
        _this.addChild(_this._barLayer);
        _this.addChild(_this._alertLayer);
        return _this;
    }
    Object.defineProperty(UIController, "instance", {
        get: function () {
            if (!this._instance) {
                this._instance = new UIController();
            }
            return this._instance;
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(UIController.prototype, "innerLayer", {
        /** 提示层 */
        get: function () { return this._innerLayer; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UIController.prototype, "alertLayer", {
        /** 提示层 */
        get: function () { return this._alertLayer; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UIController.prototype, "mainLayer", {
        /** 主要ui层 */
        get: function () { return this._mainLayer; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UIController.prototype, "barLayer", {
        /** 栏目ui层 */
        get: function () { return this._barLayer; },
        enumerable: true,
        configurable: true
    });
    UIController.prototype.createChildren = function () {
        _super.prototype.createChildren.call(this);
    };
    /**
     * @param {ViewCreator} view UI类
     * @param {ViewFunc} func 方法回调，对UI类或UI根节点UIController进行处理，传入参数1为UI实例对象，参数2为主UI节点实例
     * @returns {UIBaseComponent} 返回处理后的UI实例对象
     * 创建UI并添加到主UI节点下，随后调用传入的方法对UI进行处理
     */
    UIController.prototype.createInnerView = function (ctor, func) {
        var view = new ctor();
        this._innerLayer.addChild(view);
        if (func) {
            func(view, this._innerLayer);
        }
        return view;
    };
    /**
     * @param {ViewCreator} view UI类
     * @param {ViewFunc} func 方法回调，对UI类或UI根节点UIController进行处理，传入参数1为UI实例对象，参数2为主UI节点实例
     * @returns {UIBaseComponent} 返回处理后的UI实例对象
     * 创建UI并添加到主UI节点下，随后调用传入的方法对UI进行处理
     */
    UIController.prototype.createView = function (ctor, func) {
        var view = new ctor();
        this._mainLayer.addChild(view);
        if (func) {
            func(view, this._mainLayer);
        }
        return view;
    };
    /**
     * @param {ViewCreator} view UI类
     * @param {ViewFunc} func 方法回调，对UI类或UI根节点UIController进行处理，传入参数1为UI实例对象，参数2为主UI节点实例
     * @returns {UIBaseComponent} 返回处理后的UI实例对象
     * 创建UI并添加到栏目UI节点下，随后调用传入的方法对UI进行处理
     */
    UIController.prototype.createBarView = function (ctor, func) {
        var view = new ctor();
        this._barLayer.addChild(view);
        if (func) {
            func(view, this._barLayer);
        }
        return view;
    };
    /**
     * @param {ViewCreator} view UI类
     * @param {ViewFunc} func 方法回调，对UI类或UI根节点UIController进行处理，传入参数1为UI实例对象，参数2为提示UI节点实例
     * @returns {UIBaseComponent} 返回处理后的UI实例对象
     * 创建UI并添加到提示UI节点下，随后调用传入的方法对UI进行处理
     */
    UIController.prototype.alertView = function (ctor, func) {
        var view = new ctor();
        this.alertLayer.addChild(view);
        if (func) {
            func(view, this.alertLayer);
        }
        return view;
    };
    /**
     * 关闭界面
     */
    UIController.prototype.closeView = function (view) {
        view.onClose();
        view.parent && view.parent.removeChild(view);
    };
    return UIController;
}(eui.UILayer));
__reflect(UIController.prototype, "UIController");
