var __reflect = (this && this.__reflect) || function (p, c, t) {
    p.__class__ = c, t ? t.push(c) : t = [c], p.__types__ = p.__types__ ? t.concat(p.__types__) : t;
};
var __extends = this && this.__extends || function __extends(t, e) { 
 function r() { 
 this.constructor = t;
}
for (var i in e) e.hasOwnProperty(i) && (t[i] = e[i]);
r.prototype = e.prototype, t.prototype = new r();
};
var chipConfig = [
    { value: 0.1, color: 0x93100e, bg: 'chip_r_t' },
    { value: 0.5, color: 0x126ae4, bg: 'chip_b_t' },
    { value: 1, color: 0x7630a6, bg: 'chip_p_t' },
    { value: 5, color: 0x196b31, bg: 'chip_b_t' },
    { value: 10, color: 0x7f781b, bg: 'chip_y_t' },
    { value: 20, color: 0x6c431e, bg: 'chip_o_t' }
];
var CHIPSIZE = {
    SMALL: 1,
    LARGE: 2
};
var UI_Bet = (function (_super) {
    __extends(UI_Bet, _super);
    function UI_Bet() {
        var _this = _super.call(this) || this;
        _this.chipElements = [];
        _this.chipNodePool = [];
        return _this;
    }
    /**
     * 绑定事件
     */
    UI_Bet.prototype.bindEvents = function () {
        _super.prototype.bindEvents.call(this);
        mouse.setButtonMode(this.gtTipsBtn, true);
        mouse.setButtonMode(this.clearBtn, true);
        mouse.setButtonMode(this.confirmBtn, true);
        mouse.setButtonMode(this.autoConfirmBtn, true);
        this.clearBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onClearBtn, this);
        this.confirmBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onConfirmBtn, this);
        this.autoConfirmBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onAutoConfirmBtn, this);
    };
    /**
     * 创建完成时调用
     */
    UI_Bet.prototype.onCreate = function () {
        _super.prototype.onCreate.call(this);
        this.render();
        this.onLangChange();
    };
    /**
     * 渲染UI时调用
     */
    UI_Bet.prototype.render = function () {
        this.initRadioButtonWithGroup();
    };
    UI_Bet.prototype.onClearBtn = function (ev) {
        AudiosMgr.instance.playButtonClick();
        this.clearChip();
    };
    UI_Bet.prototype.clearChip = function () {
        this.chipNodePool.forEach(function (node) {
            node.parent.removeChild(node);
        });
        Bet.instance.setChipNodes(this.chipNodePool);
        this.chipNodePool = [];
    };
    //TODO user confirm bet
    UI_Bet.prototype.onConfirmBtn = function (ev) {
        AudiosMgr.instance.playButtonClick();
        if (UserMgr.instance.isLogin()) {
            console.log('confirm bet');
        }
    };
    UI_Bet.prototype.onAutoConfirmBtn = function (ev) {
        AudiosMgr.instance.playButtonClick();
        if (UserMgr.instance.isLogin()) {
            Auto.instance.openAutoView();
        }
    };
    UI_Bet.prototype.initRadioButtonWithGroup = function () {
        var _this = this;
        this.radioGroup = new eui.RadioButtonGroup();
        this.radioGroup.addEventListener(eui.UIEvent.CHANGE, this.radioChangeHandler, this);
        chipConfig.forEach(function (config, index) {
            var rdb = new eui.RadioButton();
            rdb.skinName = chipItem;
            rdb.label = config.value.toString();
            rdb['labelDisplay'].textColor = config.color;
            rdb['chipItemImage'].source = config.bg;
            rdb.value = config.value;
            mouse.setButtonMode(rdb, true);
            rdb.group = _this.radioGroup;
            rdb.x = 10 + rdb.width * index;
            _this.chipElements.push(rdb);
            _this.chipGroup.addChild(rdb);
        });
    };
    UI_Bet.prototype.radioChangeHandler = function (evt) {
        AudiosMgr.instance.playButtonClick();
        var radioGroup = evt.target;
        this.chipElements.forEach(function (radio) {
            egret.Tween.removeTweens(radio);
            if (radio == radioGroup.selection) {
                if (radio.y == -30)
                    return;
                egret.Tween.get(radio).to({ y: -40 }, 250, egret.Ease.sineIn);
            }
            else {
                if (radio.y == 0)
                    return;
                egret.Tween.get(radio).to({ y: 0 }, 250, egret.Ease.sineIn);
            }
        });
        Bet.instance.chipValue = radioGroup.selectedValue;
    };
    UI_Bet.prototype.getLocalPoint = function (childNode) {
        var x = childNode.width / 2;
        var y = childNode.height / 2;
        while (childNode != this) {
            x += childNode.x;
            y += childNode.y;
            childNode = childNode.parent;
        }
        return new egret.Point(x, y);
    };
    UI_Bet.prototype.chipIn = function (contaniner, stageX, stageY, chipNode) {
        var start = this.radioGroup.selection;
        var localStart = start.localToGlobal(0, 0);
        var localEnd = new egret.Point(stageX, stageY);
        contaniner.addChild(chipNode);
        this.chipNodePool.push(chipNode);
        chipNode.x = localStart.x;
        chipNode.y = localStart.y;
        egret.Tween.get(chipNode).to({ x: localEnd.x, y: localEnd.y }, 300, egret.Ease.sineIn);
    };
    //TODO render gamestart
    UI_Bet.prototype.renderGameStart = function () {
        this.confirmBtn.enabled = true;
        this.clearChip();
    };
    //TODO render lotteryInfo
    UI_Bet.prototype.renderLotteryInfo = function () {
        this.confirmBtn.enabled = false;
        if (this.radioGroup.selectedValue) {
            egret.Tween.get(this.radioGroup.selection).to({ y: 0 }, 250, egret.Ease.sineIn);
            this.radioGroup.selectedValue = null;
        }
    };
    /**
     * 改变语言时调用
     */
    UI_Bet.prototype.onLangChange = function (ev) {
        var Bet = Lang.instance.lang().Bet;
        this.clearBtn.label = Bet.clear;
        this.confirmBtn.label = Bet.confirmBet;
        this.autoConfirmBtn.label = Bet.autoBet;
        this.thisTimeBet.text = Bet.thisTime;
        this.thisPhaseBet.text = Bet.thisPhase;
        this.getBetGtLangText.text = this.getBetGtLangText0.text = Bet.getBetGtLangText;
        this.gtTips1.text = Bet.gtTips1;
        this.gtTips2.text = Bet.gtTips2;
    };
    /**
     * 界面关闭时调用
     */
    UI_Bet.prototype.onClose = function () {
    };
    return UI_Bet;
}(UIBaseComponent));
__reflect(UI_Bet.prototype, "UI_Bet");
