var __reflect = (this && this.__reflect) || function (p, c, t) {
    p.__class__ = c, t ? t.push(c) : t = [c], p.__types__ = p.__types__ ? t.concat(p.__types__) : t;
};
var __extends = this && this.__extends || function __extends(t, e) { 
 function r() { 
 this.constructor = t;
}
for (var i in e) e.hasOwnProperty(i) && (t[i] = e[i]);
r.prototype = e.prototype, t.prototype = new r();
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var UI_Index = (function (_super) {
    __extends(UI_Index, _super);
    function UI_Index() {
        var _this = _super.call(this) || this;
        _this.betArr = [];
        _this.myCardArr = [];
        _this.dealerCardArr = [];
        _this.winArr = [];
        return _this;
    }
    /**
     * 绑定事件
     */
    UI_Index.prototype.bindEvents = function () {
        _super.prototype.bindEvents.call(this);
        mouse.setButtonMode(this.betMyWinGroup, true);
        mouse.setButtonMode(this.betDealerWinGroup, true);
        mouse.setButtonMode(this.betMyDoubleGroup, true);
        mouse.setButtonMode(this.betDrawGroup, true);
        mouse.setButtonMode(this.betDealerDoubleGroup, true);
        mouse.setButtonMode(this.musicToggle, true);
        this.betMyWinGroup.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onChipBtn, this);
        this.betDealerWinGroup.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onChipBtn, this);
        this.betMyDoubleGroup.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onChipBtn, this);
        this.betDrawGroup.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onChipBtn, this);
        this.betDealerDoubleGroup.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onChipBtn, this);
        this.musicToggle.addEventListener(eui.UIEvent.CHANGE, this.onMusicToggle, this);
        this.tradeBtn && this.tradeBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onTradeBtn, this);
        this.rateBtn && this.rateBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onRateBtn, this);
        this.chipComponent.touchEnabled = false;
        this.chipComponent.touchChildren = false;
    };
    /**
     * 创建完成时调用
     */
    UI_Index.prototype.onCreate = function () {
        _super.prototype.onCreate.call(this);
        this.betArr.push(this.betMyWinGroup, this.betDealerWinGroup, this.betDrawGroup, this.betDealerDoubleGroup, this.betMyDoubleGroup);
        this.winArr.push(this.betMyWinImg, this.betDrawWinImg, this.betDealerWinImg, this.betDealerDoubleWinImg, this.betMyDoubleWinImg);
        this.myCardArr.push(this.myCard1, this.myCard2, this.myCard3);
        this.dealerCardArr.push(this.dealerCard1, this.dealerCard2, this.dealerCard3);
        this.setWinGroupVisible(false);
        this.setCardGroupVisible(false);
        this.addComponent(this.betComponent, Bet.instance.getBetView());
        this.addComponent(this.notificationComponent, Notice.instance.getNoticeView());
        this.addComponent(this.userHeaderComponent, Userinfo.instance.getUserHeaderView());
        if (!GAME_ISMOBILE) {
            this.addComponent(this.rateComponent, Rate.instance.getRateView());
            this.addComponent(this.tradeComponent, Trade.instance.getTradeView());
        }
        this.render();
        this.onLangChange();
        this.rateComponent.touchThrough = true;
        this.tradeComponent.touchThrough = true;
    };
    /**
     * 渲染UI时调用
     */
    UI_Index.prototype.render = function () {
        this.musicToggle.selected = AudiosMgr.instance.bgmAllow;
    };
    //TODO render gameInfo
    UI_Index.prototype.renderGameInfo = function (gameInfo) {
        console.log('gameInfo:', gameInfo);
        var state = gameInfo.state;
        if (state == 1) {
            this.renderGameStart(gameInfo);
        }
        else if (state == 2) {
            this.renderGameBet(gameInfo);
        }
    };
    //TODO render gamestart
    UI_Index.prototype.renderGameStart = function (gameInfo) {
        var _this = this;
        AlertMgr.instance.showAlert('游戏开始');
        this.setBetGroupEnable(true);
        this.setWinGroupVisible(false);
        this.setCardGroupVisible(false);
        this.myCountText.text = this.dealerCountText.text = '';
        setTimeout(function () {
            var time = gameInfo.time, seed = gameInfo.seed;
            _this.clockText.text = time.toString();
            _this.clockTimer = setInterval(function () {
                time--;
                _this.clockText.text = time.toString();
                if (time == 0) {
                    console.log('clock stop');
                    clearInterval(_this.clockTimer);
                }
            }, 1000);
        }, 2000);
        Bet.instance.renderGameStart();
    };
    //TODO render gameBet
    UI_Index.prototype.renderGameBet = function (gameInfo) {
    };
    //TODO render lotteryInfo
    UI_Index.prototype.renderLotteryInfo = function (lotteryInfo) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var player, banker, result, playerPair, bankerPair, Index;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log('lotteryInfo:', lotteryInfo);
                        this.setBetGroupEnable(false);
                        clearInterval(this.clockTimer);
                        player = lotteryInfo.player, banker = lotteryInfo.banker, result = lotteryInfo.result, playerPair = lotteryInfo.playerPair, bankerPair = lotteryInfo.bankerPair;
                        Index = Lang.instance.lang().Index;
                        AlertMgr.instance.showAlert(Index.rewarding);
                        this.myCountText.text = (player.reduce(function (prev, cur) { return prev + _this.toPoker(cur); }, 0) % 10).toString();
                        this.dealerCountText.text = (banker.reduce(function (prev, cur) { return prev + _this.toPoker(cur); }, 0) % 10).toString();
                        this.clockText.text = Index.rewarding;
                        Bet.instance.renderLotteryInfo();
                        return [4 /*yield*/, this.showLotteryPoker(player, banker)];
                    case 1:
                        _a.sent();
                        this.showLotteryResult(result, bankerPair, playerPair);
                        return [2 /*return*/];
                }
            });
        });
    };
    UI_Index.prototype.setBetGroupEnable = function (enable) {
        this.betArr.forEach(function (ele) { ele.touchEnabled = ele.touchChildren = enable; });
    };
    UI_Index.prototype.setCardGroupVisible = function (visible) {
        this.myCardArr.forEach(function (ele) { ele.visible = visible; });
        this.dealerCardArr.forEach(function (ele) { ele.visible = visible; });
    };
    UI_Index.prototype.setWinGroupVisible = function (visible) {
        this.winArr.forEach(function (ele) { ele.visible = visible; });
    };
    UI_Index.prototype.showLotteryPoker = function (player, banker) {
        return __awaiter(this, void 0, void 0, function () {
            var i, len;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        i = 0, len = Math.max(player.length, banker.length);
                        _a.label = 1;
                    case 1:
                        if (!(i < len)) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.showPoker(this.myCardArr[i], player[i])];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.showPoker(this.dealerCardArr[i], banker[i])];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 1];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    UI_Index.prototype.showLotteryResult = function (result, bankerPair, playerPair) {
        this.setWinGroupVisible(false);
        this.betDealerDoubleWinImg.visible = bankerPair;
        this.betMyDoubleWinImg.visible = playerPair;
        this.betMyWinImg.visible = result === 'player';
        this.betDrawWinImg.visible = result === 'tie';
        this.betDealerWinImg.visible = result === 'banker';
    };
    UI_Index.prototype.showPoker = function (element, value) {
        var _this = this;
        if (!value)
            return null;
        return new Promise(function (resovle, reject) {
            element.visible = true;
            var imgUrl = "poker_" + _this.toPoker(value) + "_" + _this.toPokerColour(value);
            element.source = imgUrl;
            setTimeout(function () {
                resovle();
            }, 500);
        });
    };
    UI_Index.prototype.setMusicToggle = function (selected) {
        console.log('musicToggle:', selected);
        this.musicToggle.selected = selected;
    };
    //TODO music control
    UI_Index.prototype.onMusicToggle = function (ev) {
        console.log('onMusicToggle:', this.musicToggle.selected);
        AudiosMgr.instance.setBgmAllow(this.musicToggle.selected);
        if (this.musicToggle.selected) {
            AudiosMgr.instance.playBgm();
        }
        else {
            AudiosMgr.instance.stopBgm();
        }
    };
    UI_Index.prototype.onTradeBtn = function (ev) {
        AudiosMgr.instance.playButtonClick();
        Trade.instance.openTradeView();
    };
    //RateBtn-h5
    UI_Index.prototype.onRateBtn = function (ev) {
        AudiosMgr.instance.playButtonClick();
        Rate.instance.openRateView();
    };
    UI_Index.prototype.toPokerColour = function (poker) {
        return Math.ceil(poker / 13);
    };
    UI_Index.prototype.toPoker = function (poker) {
        return ((poker - 1) % 13) + 1;
    };
    /**
     * 改变语言时调用
     */
    UI_Index.prototype.onLangChange = function (ev) {
        var _a = Lang.instance.lang(), Index = _a.Index, Bet = _a.Bet;
        this.onlineNumber.text = Index.online + '：55';
        this.dealerIdentityText.text = Bet.banker.toUpperCase(); //庄
        this.myIdentityText.text = Bet.player.toUpperCase(); //闲
        this.betMyWinText.text = Index.playerWin.toUpperCase() + '\n1:1'; //閒赢1 : 1
        this.betDealerWinText.text = Index.bankerWin.toUpperCase() + '\n1:0.95'; //莊赢1 : 0.95
        this.betMyDoubleText.text = Bet.bankerPair.toUpperCase() + '\n1:11'; //閒對1:11
        this.betDrawText.text = Bet.tie.toUpperCase() + '\n1:11'; //和1:11
        this.betDealerDoubleText.text = Bet.bankerPair.toUpperCase() + '\n1:11'; //莊對1:11
        if (GAME_ISMOBILE) {
            this.rateBtn.label = Index.rateBtnText;
            this.tradeBtn.label = Index.tradeBtnText;
        }
    };
    UI_Index.prototype.addComponent = function (target, component) {
        target.addChild(component);
    };
    /**
     * 下注区域事件
     */
    UI_Index.prototype.onChipBtn = function (ev) {
        AudiosMgr.instance.playButtonClick();
        if (Bet.instance.chipValue == 0) {
            console.log('请选择筹码');
            return;
        }
        else {
            if (UserMgr.instance.isLogin()) {
                // console.log(ev.stageX, ev.stageY);
                Bet.instance.largeChipIn(this.chipComponent, ev.stageX, ev.stageY);
            }
        }
    };
    /**
     * 界面关闭时调用
     */
    UI_Index.prototype.onClose = function () {
    };
    return UI_Index;
}(UIBaseComponent));
__reflect(UI_Index.prototype, "UI_Index");
