type Long = protobuf.Long;

/** Namespace pb_10_network. */
declare namespace pb_10_network {

    /** Properties of a pbTest. */
    interface IpbTest {

        /** pbTest number */
        number: number;

        /** pbTest string */
        string: string;
    }

    /** Represents a pbTest. */
    class pbTest implements IpbTest {

        /**
         * Constructs a new pbTest.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_10_network.IpbTest);

        /** pbTest number. */
        public number: number;

        /** pbTest string. */
        public string: string;

        /**
         * Creates a new pbTest instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbTest instance
         */
        public static create(properties?: pb_10_network.IpbTest): pb_10_network.pbTest;

        /**
         * Encodes the specified pbTest message. Does not implicitly {@link pb_10_network.pbTest.verify|verify} messages.
         * @param message pbTest message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_10_network.IpbTest, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbTest message, length delimited. Does not implicitly {@link pb_10_network.pbTest.verify|verify} messages.
         * @param message pbTest message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_10_network.IpbTest, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbTest message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbTest
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_10_network.pbTest;

        /**
         * Decodes a pbTest message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbTest
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_10_network.pbTest;

        /**
         * Verifies a pbTest message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbTest message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbTest
         */
        public static fromObject(object: { [k: string]: any }): pb_10_network.pbTest;

        /**
         * Creates a plain object from a pbTest message. Also converts values to other types if specified.
         * @param message pbTest
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_10_network.pbTest, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbTest to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a pbServerTime. */
    interface IpbServerTime {

        /** pbServerTime time */
        time: number;
    }

    /** Represents a pbServerTime. */
    class pbServerTime implements IpbServerTime {

        /**
         * Constructs a new pbServerTime.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_10_network.IpbServerTime);

        /** pbServerTime time. */
        public time: number;

        /**
         * Creates a new pbServerTime instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbServerTime instance
         */
        public static create(properties?: pb_10_network.IpbServerTime): pb_10_network.pbServerTime;

        /**
         * Encodes the specified pbServerTime message. Does not implicitly {@link pb_10_network.pbServerTime.verify|verify} messages.
         * @param message pbServerTime message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_10_network.IpbServerTime, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbServerTime message, length delimited. Does not implicitly {@link pb_10_network.pbServerTime.verify|verify} messages.
         * @param message pbServerTime message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_10_network.IpbServerTime, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbServerTime message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbServerTime
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_10_network.pbServerTime;

        /**
         * Decodes a pbServerTime message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbServerTime
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_10_network.pbServerTime;

        /**
         * Verifies a pbServerTime message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbServerTime message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbServerTime
         */
        public static fromObject(object: { [k: string]: any }): pb_10_network.pbServerTime;

        /**
         * Creates a plain object from a pbServerTime message. Also converts values to other types if specified.
         * @param message pbServerTime
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_10_network.pbServerTime, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbServerTime to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a pbErrorMsg. */
    interface IpbErrorMsg {

        /** pbErrorMsg code */
        code: number;

        /** pbErrorMsg word */
        word?: (string|null);
    }

    /** Represents a pbErrorMsg. */
    class pbErrorMsg implements IpbErrorMsg {

        /**
         * Constructs a new pbErrorMsg.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_10_network.IpbErrorMsg);

        /** pbErrorMsg code. */
        public code: number;

        /** pbErrorMsg word. */
        public word: string;

        /**
         * Creates a new pbErrorMsg instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbErrorMsg instance
         */
        public static create(properties?: pb_10_network.IpbErrorMsg): pb_10_network.pbErrorMsg;

        /**
         * Encodes the specified pbErrorMsg message. Does not implicitly {@link pb_10_network.pbErrorMsg.verify|verify} messages.
         * @param message pbErrorMsg message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_10_network.IpbErrorMsg, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbErrorMsg message, length delimited. Does not implicitly {@link pb_10_network.pbErrorMsg.verify|verify} messages.
         * @param message pbErrorMsg message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_10_network.IpbErrorMsg, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbErrorMsg message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbErrorMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_10_network.pbErrorMsg;

        /**
         * Decodes a pbErrorMsg message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbErrorMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_10_network.pbErrorMsg;

        /**
         * Verifies a pbErrorMsg message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbErrorMsg message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbErrorMsg
         */
        public static fromObject(object: { [k: string]: any }): pb_10_network.pbErrorMsg;

        /**
         * Creates a plain object from a pbErrorMsg message. Also converts values to other types if specified.
         * @param message pbErrorMsg
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_10_network.pbErrorMsg, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbErrorMsg to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a pbToastMsg. */
    interface IpbToastMsg {

        /** pbToastMsg code */
        code: number;

        /** pbToastMsg word */
        word?: (string|null);
    }

    /** Represents a pbToastMsg. */
    class pbToastMsg implements IpbToastMsg {

        /**
         * Constructs a new pbToastMsg.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_10_network.IpbToastMsg);

        /** pbToastMsg code. */
        public code: number;

        /** pbToastMsg word. */
        public word: string;

        /**
         * Creates a new pbToastMsg instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbToastMsg instance
         */
        public static create(properties?: pb_10_network.IpbToastMsg): pb_10_network.pbToastMsg;

        /**
         * Encodes the specified pbToastMsg message. Does not implicitly {@link pb_10_network.pbToastMsg.verify|verify} messages.
         * @param message pbToastMsg message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_10_network.IpbToastMsg, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbToastMsg message, length delimited. Does not implicitly {@link pb_10_network.pbToastMsg.verify|verify} messages.
         * @param message pbToastMsg message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_10_network.IpbToastMsg, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbToastMsg message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbToastMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_10_network.pbToastMsg;

        /**
         * Decodes a pbToastMsg message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbToastMsg
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_10_network.pbToastMsg;

        /**
         * Verifies a pbToastMsg message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbToastMsg message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbToastMsg
         */
        public static fromObject(object: { [k: string]: any }): pb_10_network.pbToastMsg;

        /**
         * Creates a plain object from a pbToastMsg message. Also converts values to other types if specified.
         * @param message pbToastMsg
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_10_network.pbToastMsg, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbToastMsg to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }
}

/** Namespace pb_11_play. */
declare namespace pb_11_play {

    /** Properties of a pbString. */
    interface IpbString {

        /** pbString val */
        val: string;
    }

    /** Represents a pbString. */
    class pbString implements IpbString {

        /**
         * Constructs a new pbString.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_11_play.IpbString);

        /** pbString val. */
        public val: string;

        /**
         * Creates a new pbString instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbString instance
         */
        public static create(properties?: pb_11_play.IpbString): pb_11_play.pbString;

        /**
         * Encodes the specified pbString message. Does not implicitly {@link pb_11_play.pbString.verify|verify} messages.
         * @param message pbString message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_11_play.IpbString, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbString message, length delimited. Does not implicitly {@link pb_11_play.pbString.verify|verify} messages.
         * @param message pbString message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_11_play.IpbString, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbString message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbString
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_11_play.pbString;

        /**
         * Decodes a pbString message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbString
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_11_play.pbString;

        /**
         * Verifies a pbString message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbString message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbString
         */
        public static fromObject(object: { [k: string]: any }): pb_11_play.pbString;

        /**
         * Creates a plain object from a pbString message. Also converts values to other types if specified.
         * @param message pbString
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_11_play.pbString, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbString to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a pbUInt32. */
    interface IpbUInt32 {

        /** pbUInt32 val */
        val: number;
    }

    /** Represents a pbUInt32. */
    class pbUInt32 implements IpbUInt32 {

        /**
         * Constructs a new pbUInt32.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_11_play.IpbUInt32);

        /** pbUInt32 val. */
        public val: number;

        /**
         * Creates a new pbUInt32 instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbUInt32 instance
         */
        public static create(properties?: pb_11_play.IpbUInt32): pb_11_play.pbUInt32;

        /**
         * Encodes the specified pbUInt32 message. Does not implicitly {@link pb_11_play.pbUInt32.verify|verify} messages.
         * @param message pbUInt32 message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_11_play.IpbUInt32, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbUInt32 message, length delimited. Does not implicitly {@link pb_11_play.pbUInt32.verify|verify} messages.
         * @param message pbUInt32 message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_11_play.IpbUInt32, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbUInt32 message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbUInt32
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_11_play.pbUInt32;

        /**
         * Decodes a pbUInt32 message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbUInt32
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_11_play.pbUInt32;

        /**
         * Verifies a pbUInt32 message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbUInt32 message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbUInt32
         */
        public static fromObject(object: { [k: string]: any }): pb_11_play.pbUInt32;

        /**
         * Creates a plain object from a pbUInt32 message. Also converts values to other types if specified.
         * @param message pbUInt32
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_11_play.pbUInt32, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbUInt32 to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a pbUser. */
    interface IpbUser {

        /** pbUser account */
        account: string;

        /** pbUser eos */
        eos: string;

        /** pbUser gt */
        gt: string;
    }

    /** Represents a pbUser. */
    class pbUser implements IpbUser {

        /**
         * Constructs a new pbUser.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_11_play.IpbUser);

        /** pbUser account. */
        public account: string;

        /** pbUser eos. */
        public eos: string;

        /** pbUser gt. */
        public gt: string;

        /**
         * Creates a new pbUser instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbUser instance
         */
        public static create(properties?: pb_11_play.IpbUser): pb_11_play.pbUser;

        /**
         * Encodes the specified pbUser message. Does not implicitly {@link pb_11_play.pbUser.verify|verify} messages.
         * @param message pbUser message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_11_play.IpbUser, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbUser message, length delimited. Does not implicitly {@link pb_11_play.pbUser.verify|verify} messages.
         * @param message pbUser message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_11_play.IpbUser, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbUser message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbUser
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_11_play.pbUser;

        /**
         * Decodes a pbUser message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbUser
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_11_play.pbUser;

        /**
         * Verifies a pbUser message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbUser message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbUser
         */
        public static fromObject(object: { [k: string]: any }): pb_11_play.pbUser;

        /**
         * Creates a plain object from a pbUser message. Also converts values to other types if specified.
         * @param message pbUser
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_11_play.pbUser, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbUser to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a pbBet. */
    interface IpbBet {

        /** pbBet type */
        type: number;

        /** pbBet account */
        account: string;

        /** pbBet counter */
        counter: number;

        /** pbBet quantity */
        quantity: number;

        /** pbBet total */
        total?: (string|null);

        /** pbBet x */
        x?: (number|null);

        /** pbBet y */
        y?: (number|null);
    }

    /** Represents a pbBet. */
    class pbBet implements IpbBet {

        /**
         * Constructs a new pbBet.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_11_play.IpbBet);

        /** pbBet type. */
        public type: number;

        /** pbBet account. */
        public account: string;

        /** pbBet counter. */
        public counter: number;

        /** pbBet quantity. */
        public quantity: number;

        /** pbBet total. */
        public total: string;

        /** pbBet x. */
        public x: number;

        /** pbBet y. */
        public y: number;

        /**
         * Creates a new pbBet instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbBet instance
         */
        public static create(properties?: pb_11_play.IpbBet): pb_11_play.pbBet;

        /**
         * Encodes the specified pbBet message. Does not implicitly {@link pb_11_play.pbBet.verify|verify} messages.
         * @param message pbBet message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_11_play.IpbBet, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbBet message, length delimited. Does not implicitly {@link pb_11_play.pbBet.verify|verify} messages.
         * @param message pbBet message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_11_play.IpbBet, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbBet message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbBet
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_11_play.pbBet;

        /**
         * Decodes a pbBet message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbBet
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_11_play.pbBet;

        /**
         * Verifies a pbBet message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbBet message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbBet
         */
        public static fromObject(object: { [k: string]: any }): pb_11_play.pbBet;

        /**
         * Creates a plain object from a pbBet message. Also converts values to other types if specified.
         * @param message pbBet
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_11_play.pbBet, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbBet to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a pbBetList. */
    interface IpbBetList {

        /** pbBetList list */
        list?: (pb_11_play.IpbBet[]|null);
    }

    /** Represents a pbBetList. */
    class pbBetList implements IpbBetList {

        /**
         * Constructs a new pbBetList.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_11_play.IpbBetList);

        /** pbBetList list. */
        public list: pb_11_play.IpbBet[];

        /**
         * Creates a new pbBetList instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbBetList instance
         */
        public static create(properties?: pb_11_play.IpbBetList): pb_11_play.pbBetList;

        /**
         * Encodes the specified pbBetList message. Does not implicitly {@link pb_11_play.pbBetList.verify|verify} messages.
         * @param message pbBetList message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_11_play.IpbBetList, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbBetList message, length delimited. Does not implicitly {@link pb_11_play.pbBetList.verify|verify} messages.
         * @param message pbBetList message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_11_play.IpbBetList, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbBetList message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbBetList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_11_play.pbBetList;

        /**
         * Decodes a pbBetList message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbBetList
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_11_play.pbBetList;

        /**
         * Verifies a pbBetList message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbBetList message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbBetList
         */
        public static fromObject(object: { [k: string]: any }): pb_11_play.pbBetList;

        /**
         * Creates a plain object from a pbBetList message. Also converts values to other types if specified.
         * @param message pbBetList
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_11_play.pbBetList, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbBetList to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a pbBetInfo. */
    interface IpbBetInfo {

        /** pbBetInfo type */
        type: number;

        /** pbBetInfo list */
        list?: (pb_11_play.IpbBet[]|null);
    }

    /** Represents a pbBetInfo. */
    class pbBetInfo implements IpbBetInfo {

        /**
         * Constructs a new pbBetInfo.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_11_play.IpbBetInfo);

        /** pbBetInfo type. */
        public type: number;

        /** pbBetInfo list. */
        public list: pb_11_play.IpbBet[];

        /**
         * Creates a new pbBetInfo instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbBetInfo instance
         */
        public static create(properties?: pb_11_play.IpbBetInfo): pb_11_play.pbBetInfo;

        /**
         * Encodes the specified pbBetInfo message. Does not implicitly {@link pb_11_play.pbBetInfo.verify|verify} messages.
         * @param message pbBetInfo message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_11_play.IpbBetInfo, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbBetInfo message, length delimited. Does not implicitly {@link pb_11_play.pbBetInfo.verify|verify} messages.
         * @param message pbBetInfo message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_11_play.IpbBetInfo, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbBetInfo message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbBetInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_11_play.pbBetInfo;

        /**
         * Decodes a pbBetInfo message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbBetInfo
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_11_play.pbBetInfo;

        /**
         * Verifies a pbBetInfo message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbBetInfo message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbBetInfo
         */
        public static fromObject(object: { [k: string]: any }): pb_11_play.pbBetInfo;

        /**
         * Creates a plain object from a pbBetInfo message. Also converts values to other types if specified.
         * @param message pbBetInfo
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_11_play.pbBetInfo, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbBetInfo to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a pbGame. */
    interface IpbGame {

        /** pbGame id */
        id: number;

        /** pbGame state */
        state: number;

        /** pbGame time */
        time: number;

        /** pbGame bet */
        bet?: (pb_11_play.IpbBetInfo[]|null);

        /** pbGame seed */
        seed: string;
    }

    /** Represents a pbGame. */
    class pbGame implements IpbGame {

        /**
         * Constructs a new pbGame.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_11_play.IpbGame);

        /** pbGame id. */
        public id: number;

        /** pbGame state. */
        public state: number;

        /** pbGame time. */
        public time: number;

        /** pbGame bet. */
        public bet: pb_11_play.IpbBetInfo[];

        /** pbGame seed. */
        public seed: string;

        /**
         * Creates a new pbGame instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbGame instance
         */
        public static create(properties?: pb_11_play.IpbGame): pb_11_play.pbGame;

        /**
         * Encodes the specified pbGame message. Does not implicitly {@link pb_11_play.pbGame.verify|verify} messages.
         * @param message pbGame message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_11_play.IpbGame, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbGame message, length delimited. Does not implicitly {@link pb_11_play.pbGame.verify|verify} messages.
         * @param message pbGame message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_11_play.IpbGame, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbGame message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbGame
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_11_play.pbGame;

        /**
         * Decodes a pbGame message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbGame
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_11_play.pbGame;

        /**
         * Verifies a pbGame message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbGame message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbGame
         */
        public static fromObject(object: { [k: string]: any }): pb_11_play.pbGame;

        /**
         * Creates a plain object from a pbGame message. Also converts values to other types if specified.
         * @param message pbGame
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_11_play.pbGame, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbGame to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a pbLottery. */
    interface IpbLottery {

        /** pbLottery player */
        player?: (number[]|null);

        /** pbLottery banker */
        banker?: (number[]|null);

        /** pbLottery result */
        result: string;

        /** pbLottery playerPair */
        playerPair: boolean;

        /** pbLottery bankerPair */
        bankerPair: boolean;
    }

    /** Represents a pbLottery. */
    class pbLottery implements IpbLottery {

        /**
         * Constructs a new pbLottery.
         * @param [properties] Properties to set
         */
        constructor(properties?: pb_11_play.IpbLottery);

        /** pbLottery player. */
        public player: number[];

        /** pbLottery banker. */
        public banker: number[];

        /** pbLottery result. */
        public result: string;

        /** pbLottery playerPair. */
        public playerPair: boolean;

        /** pbLottery bankerPair. */
        public bankerPair: boolean;

        /**
         * Creates a new pbLottery instance using the specified properties.
         * @param [properties] Properties to set
         * @returns pbLottery instance
         */
        public static create(properties?: pb_11_play.IpbLottery): pb_11_play.pbLottery;

        /**
         * Encodes the specified pbLottery message. Does not implicitly {@link pb_11_play.pbLottery.verify|verify} messages.
         * @param message pbLottery message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: pb_11_play.IpbLottery, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Encodes the specified pbLottery message, length delimited. Does not implicitly {@link pb_11_play.pbLottery.verify|verify} messages.
         * @param message pbLottery message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: pb_11_play.IpbLottery, writer?: protobuf.Writer): protobuf.Writer;

        /**
         * Decodes a pbLottery message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns pbLottery
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: (protobuf.Reader|Uint8Array), length?: number): pb_11_play.pbLottery;

        /**
         * Decodes a pbLottery message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns pbLottery
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: (protobuf.Reader|Uint8Array)): pb_11_play.pbLottery;

        /**
         * Verifies a pbLottery message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a pbLottery message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns pbLottery
         */
        public static fromObject(object: { [k: string]: any }): pb_11_play.pbLottery;

        /**
         * Creates a plain object from a pbLottery message. Also converts values to other types if specified.
         * @param message pbLottery
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: pb_11_play.pbLottery, options?: protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this pbLottery to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }
}
