/**
 * 圆圈进度条遮罩
 * @author nodep
 * @version 1.0
 */
class CricleProgress {
	private _mask: egret.Shape;
	private _w: number = 0;//直径
	private _target: egret.DisplayObject;
	private anticlockwise: boolean;
	public constructor(target: egret.DisplayObject, w: number, anticlockwise: boolean = false) {
		this._target = target;
		this._mask = new egret.Shape();
		this._mask.x = target.x;
		this._mask.y = target.y;
		target.parent.addChildAt(this._mask, target.parent.getChildIndex(this._target) + 1);
		this._target.mask = this._mask;
		this._w = w;
		this.anticlockwise = anticlockwise;
	}
	/**
		 * 设置当前的进度
		 * @param lastTime
		 * @param total
		 */
	public setProgress(lastTime: number, total: number): void {
		if (!this._mask)
			return;
		this._mask.graphics.clear();
		if (lastTime >= total) {
			this._mask.graphics.beginFill(0);
			this._mask.graphics.drawRect(0, 0, this._w, this._w);
			this._mask.graphics.endFill();
			return;
		}
		let r = this._w / 2;
		var passTime: number = 360 * lastTime / total;
		this._mask.x = this._target.x;
		this._mask.y = this._target.y;
		this._mask.graphics.beginFill(0xff0000);
		this._mask.graphics.moveTo(r, r);//绘制点移动(r, r)点
		this._mask.graphics.lineTo(r, 0);//画线到弧的起始点
		if (this.anticlockwise) {
			this._mask.graphics.drawArc(r, r, r, -90 * Math.PI / 180, (- 90 + passTime) * Math.PI / 180, false);//从起始点逆时针画弧到终点
		} else {
			this._mask.graphics.drawArc(r, r, r, -90 * Math.PI / 180, (- 90 - passTime) * Math.PI / 180, true);//从起始点逆时针画弧到终点
		}

		this._mask.graphics.lineTo(r, r);//从终点画线到圆形。到此扇形的封闭区域形成
		this._mask.graphics.endFill();
	}
}