/**
 * 下注逻辑
 */
class Bet {
	private static _instance: Bet;
	static get instance(): Bet {
		if (!this._instance) {
			this._instance = new Bet();
		}
		return this._instance;
	}

	private uiBet: UI_Bet;
	private _chipValue: number = 0;
	private chipPoolNodes = {};
	public constructor() {
	}
	get chipValue(): number {
		return this._chipValue;
	}
	set chipValue(chipValue: number) {
		this._chipValue = chipValue;
	}
	getBetView(): UI_Bet {
		return this.uiBet = UIController.instance.createView<UI_Bet>(UI_Bet);
	}
	setChipNodes(nodePool: UI_ChipItem[]): void {
		nodePool.forEach(node => {
			let key = `${node.chipValue}${node.size}`;
			if (!this.chipPoolNodes[key]) {
				this.chipPoolNodes[key] = [];
			}
			this.chipPoolNodes[key].push(node);
		})
	}
	private getChipNodes(chipValue: number, size: number): UI_ChipItem {
		let key = `${chipValue}${size}`;

		if (!this.chipPoolNodes[key]) {
			this.chipPoolNodes[key] = [];
		}

		if (this.chipPoolNodes[key].length) {
			console.log('节点池读取');
			return this.chipPoolNodes[key].pop();
		} else {
			console.log('新建节点');
			return new UI_ChipItem(chipValue, size);
		}
	}
	largeChipIn(contaniner: egret.DisplayObjectContainer, stageX: number, stageY: number): void {
		let chipNode = this.getChipNodes(this.chipValue, CHIPSIZE.LARGE);

		this.uiBet.chipIn(contaniner, stageX, stageY, chipNode);
	}
	smallChipIn(contaniner: egret.DisplayObjectContainer, stageX: number, stageY: number): void {
		let chipNode = this.getChipNodes(this.chipValue, CHIPSIZE.SMALL);

		this.uiBet.chipIn(contaniner, stageX, stageY, chipNode);
	}

	//TODO render gamestart
	renderGameStart(): void {
		this.uiBet.renderGameStart();
	}

	//TODO render lotteryInfo
	renderLotteryInfo(): void {
		this.uiBet.renderLotteryInfo();
	}

}