/**
 * 主页逻辑  
 */
class Index {
	private static _instance: Index;
	static get instance(): Index {
		if (!this._instance) {
			this._instance = new Index();
		}
		return this._instance;
	}
	public uiIndex: UI_Index;
	public constructor() {
		this.openIndexView();
		GameMgr.instance.addEventListener(SocketEvent.PROTO_MSG, this.onRecieved, this);
	}

	onRecieved(ev: SocketEvent) {
		let { protoId, length } = ev;

		if (length == 0) return;

		if (protoId == Protocol.gameInfo) {
			let gameInfo = SocketMgr.instance.handleProtobufMsg<pb_11_play.pbGame>(ev.message, pb_11_play.pbGame);
			this.uiIndex.renderGameInfo(gameInfo)
		} else if (protoId == Protocol.lottery) {
			let lotteryInfo = SocketMgr.instance.handleProtobufMsg<pb_11_play.pbLottery>(ev.message, pb_11_play.pbLottery);
			this.uiIndex.renderLotteryInfo(lotteryInfo);
		}
	}

	openIndexView(): void {
		console.log('openIndexView');
		this.uiIndex = UIController.instance.createView<UI_Index>(UI_Index);
	}

	setMusicToggle(selected: boolean): void {
		this.uiIndex && this.uiIndex.setMusicToggle(selected);
	}

	release(): void {

	}
}