/**
 * 用于显示错误信息以及其他提示
 */
class AlertMgr {
	private static _instance: AlertMgr;

	static get instance(): AlertMgr {
		if (!this._instance) {
			this._instance = new AlertMgr();
		}
		return this._instance;
	}


	private alertMsg: string[] = [];
	private uiAlert: UI_Alert;

	private constructor() {
	}

	register(): void {

	}


	private onReceived(ev: SocketEvent): void {

	}

	showAlert(msg: string): void {
		if (!this.uiAlert) {
			this.uiAlert = UIController.instance.alertView<UI_Alert>(UI_Alert);
		}
		this.uiAlert.visible = true;
		this.uiAlert.showAlert(msg);

		setTimeout(() => {
			this.hideAlert();
		}, 2000);
	}

	hideAlert(): void {
		this.uiAlert.visible = false;
	}

	release(): void {

	}
}