class AudiosMgr {
	private static _instance: AudiosMgr;

	static get instance(): AudiosMgr {
		if (!this._instance) {
			this._instance = new AudiosMgr();
		}
		return this._instance;
	}
	private audiosRes = {};
	public bgmAllow: boolean = false;
	private bgm: egret.SoundChannel;
	private bgmPosition: number = 0;
	private constructor() {
	}

	/**获取sound资源 */
	private getAudioSource(soundName: string): egret.Sound {
		this.audiosRes[soundName] = this.audiosRes[soundName] || RES.getRes(soundName);

		return this.audiosRes[soundName];
	}

	private playSound(soundName: string, startTime: number = 0, loops: number = 1): egret.SoundChannel {
		return this.getAudioSource(soundName).play(startTime, loops);
	}

	public setBgmAllow(allow: boolean): void {
		this.bgmAllow = allow;
	}

	public playBgm(): void {
		if (this.bgm) return;
		try {
			console.log('play bgm');
			this.bgm = this.playSound('bgm_mp3', this.bgmPosition, 0);
		} catch (e) {
			console.error('bgm play error:', e);
		}
		Index.instance.setMusicToggle(true);
	}

	public stopBgm(): void {
		if (this.bgm) {
			console.log('stop bgm');
			this.bgmPosition = this.bgm.position;
			this.bgm.stop();
			this.bgm = null;
			Index.instance.setMusicToggle(false);
		}
	}

	public playButtonClick(): egret.SoundChannel {
		return this.playSound('button-click_mp3');
	}
}