class UI_Auto extends UIBaseComponent {
	private title: eui.Label;
	private autoTips: eui.Label;
	private planEos: eui.Label;
	private planCount: eui.Label;
	private planCont: eui.Label;
	private betEos1: eui.Label;
	private betEos2: eui.Label;
	private stopEos: eui.Label;
	private winInTotal: eui.Label;
	private gained: eui.Label;
	private reset: eui.Label;
	private detail: eui.Label;
	private period: eui.Label;
	private atLeastL1: eui.Label;
	private atLeastR1: eui.Label;
	private atLeastL2: eui.Label;
	private atLeastR2: eui.Label;
	private periodTxt: eui.Label;
	private banker: eui.Label;
	private player: eui.Label;
	private tie: eui.Label;
	private bankerPair: eui.Label;
	private playerPair: eui.Label;
	private stopTipL: eui.Label;
	private stopTipR: eui.Label;
	private multiChoice: eui.Label;
	private backTipL: eui.Label;
	private backTipR: eui.Label;

	private btnClose: eui.Button;
	private btnAdd: eui.Button;
	private btnBack: eui.Button;
	private btnDetail: eui.Group;
	private btnComfirm: eui.Button;
	private inputEos: eui.TextInput;//计划投入
	private inputCount: eui.TextInput;//期数
	private inputNomal: eui.TextInput;//筹码1
	private inputRare: eui.TextInput;//筹码2
	private inputStop: eui.TextInput;//止损线

	public constructor() {
		super();
	}

	/**
	 * 绑定事件
	 */
	protected bindEvents(): void {
		super.bindEvents();

		let btnArr = ["btnClose","btnAdd","btnBack","btnDetail","btnComfirm"]

		for(let i=0; i<btnArr.length; i++) {
			mouse.setButtonMode(this[btnArr[i]], true);
		}

		this.btnClose.addEventListener(egret.TouchEvent.TOUCH_TAP,this.onBtnClose,this);
		this.btnDetail.addEventListener(egret.TouchEvent.TOUCH_TAP,this.onBtnDetail,this);
		this.btnComfirm.addEventListener(egret.TouchEvent.TOUCH_TAP,this.onBtnComfirm,this);
	}

	/**
	 * 创建完成时调用
	 */
	protected onCreate(): void {
		super.onCreate();
		this.render();
		this.onLangChange();
	}

	private onBtnClose(){
		Auto.instance.closeAutoView();
	}

	private onBtnDetail(){
		Auto.instance.openAutoDetailView();
	}

	private onBtnComfirm(){
		Auto.instance.closeAutoView();
	}
	

	/**
	 * 渲染UI时调用
	 */
	protected render(): void {
	}

	/**
	 * 改变语言时调用
	 */
	protected onLangChange(ev?: egret.Event): void {
		let {Bet,Auto} = Lang.instance.lang();
		let isZn = Lang.instance.langEnum == 0 ;
		let backCount = 1;

		//纯label赋值
		let txtArr = [
			"title","autoTips","planEos","planCount","planCont","stopEos",
			"winInTotal","gained","reset","detail","period","periodTxt",
			"stopTipL","stopTipR","multiChoice","backTipL"
			];
		for(let i=0; i<txtArr.length; i++) {
			let index = txtArr[i];
			this[index].text = Auto[index];
		}

		//庄闲和赋值
		let resultArr = ["banker","player","tie","bankerPair","playerPair"]
		for(let i=0; i<resultArr.length; i++) {
			let index = resultArr[i]

			this[`${index}CBox`].label = Bet[index].toUpperCase().replace(" ","\n");
			this[`${index}CBox`].labelDisplay.size = isZn ? "30" : "18";
		}

		this.backTipR.text = `${backCount} ${Auto.backTipR}`;
		this.atLeastL1.text= `${Auto.oneBet}0.5`;
		this.atLeastR1.text= Auto.atLeast;
		this.atLeastL2.text= `${Auto.oneBet}0.1`;
		this.atLeastR2.text= Auto.atLeast;
		this.btnAdd.label = Auto.add;
		this.btnBack.label = Auto.back;
		this.btnComfirm.label = Auto.startBetting;
		this.betEos1.text = this.betEos2.text = Auto.betEos;
	}

	/**
	 * 界面关闭时调用
	 */
	public onClose(): void {
	}
}