class UI_Index extends UIBaseComponent {
	private clockGroup: eui.Group;
	private userGroup: eui.Group;
	private myCardGroup: eui.Group;
	private dealerCardGroup: eui.Group;
	private betArr: eui.Group[] = [];
	private betMyWinGroup: eui.Group;
	private betDealerWinGroup: eui.Group;
	private betMyDoubleGroup: eui.Group;
	private betDrawGroup: eui.Group;
	private betDealerDoubleGroup: eui.Group;

	private myCardArr: eui.Image[] = [];
	private dealerCardArr: eui.Image[] = [];
	private myCard1: eui.Image;
	private myCard2: eui.Image;
	private myCard3: eui.Image;
	private dealerCard1: eui.Image;
	private dealerCard2: eui.Image;
	private dealerCard3: eui.Image;

	private onlineNumber: eui.Label;//当前在线人数
	private clockText: eui.Label;//时钟文本
	private myCountText: eui.Label;
	private dealerCountText: eui.Label;
	private dealerIdentityText: eui.Label;//庄
	private myIdentityText: eui.Label;//闲
	private betMyWinText: eui.Label;//閒赢1 : 1
	private betDealerWinText: eui.Label;//莊赢1 : 0.95
	private betMyDoubleText: eui.Label;//閒對1:11
	private betDrawText: eui.Label;//和1:11
	private betDealerDoubleText: eui.Label;//莊對1:11

	private notificationComponent: eui.Group;
	private userHeaderComponent: eui.Group;
	private betComponent: eui.Group;
	private rateComponent: eui.Group;
	private tradeComponent: eui.Group;
	private chipComponent: eui.Group;

	private musicToggle: eui.ToggleButton;

	private winArr: eui.Image[] = [];
	private betMyWinImg: eui.Image;
	private betDealerWinImg: eui.Image;
	private betMyDoubleWinImg: eui.Image;
	private betDrawWinImg: eui.Image;
	private betDealerDoubleWinImg: eui.Image;

	//h5
	private rateBtn: eui.Button;
	private tradeBtn: eui.Button;

	private clockTimer: number;
	public constructor() {
		super();
	}

	/**
	 * 绑定事件
	 */
	protected bindEvents(): void {
		super.bindEvents();
		mouse.setButtonMode(this.betMyWinGroup, true);
		mouse.setButtonMode(this.betDealerWinGroup, true);
		mouse.setButtonMode(this.betMyDoubleGroup, true);
		mouse.setButtonMode(this.betDrawGroup, true);
		mouse.setButtonMode(this.betDealerDoubleGroup, true);
		mouse.setButtonMode(this.musicToggle, true);

		this.betMyWinGroup.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onChipBtn, this);
		this.betDealerWinGroup.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onChipBtn, this);
		this.betMyDoubleGroup.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onChipBtn, this);
		this.betDrawGroup.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onChipBtn, this);
		this.betDealerDoubleGroup.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onChipBtn, this);
		this.musicToggle.addEventListener(eui.UIEvent.CHANGE, this.onMusicToggle, this);

		this.tradeBtn && this.tradeBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onTradeBtn, this);
		this.rateBtn && this.rateBtn.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onRateBtn, this);

		this.chipComponent.touchEnabled = false;
		this.chipComponent.touchChildren = false;
	}

	/**
	 * 创建完成时调用
	 */
	protected onCreate(): void {
		super.onCreate();
		this.betArr.push(this.betMyWinGroup, this.betDealerWinGroup, this.betDrawGroup, this.betDealerDoubleGroup, this.betMyDoubleGroup);
		this.winArr.push(this.betMyWinImg, this.betDrawWinImg, this.betDealerWinImg, this.betDealerDoubleWinImg, this.betMyDoubleWinImg);
		this.myCardArr.push(this.myCard1, this.myCard2, this.myCard3);
		this.dealerCardArr.push(this.dealerCard1, this.dealerCard2, this.dealerCard3);
		this.setWinGroupVisible(false);
		this.setCardGroupVisible(false);

		this.addComponent(this.betComponent, Bet.instance.getBetView());
		this.addComponent(this.notificationComponent, Notice.instance.getNoticeView());
		this.addComponent(this.userHeaderComponent, Userinfo.instance.getUserHeaderView());

		if (!GAME_ISMOBILE) {
			this.addComponent(this.rateComponent, Rate.instance.getRateView());
			this.addComponent(this.tradeComponent, Trade.instance.getTradeView());
		}

		this.render();
		this.onLangChange();

		this.rateComponent.touchThrough = true;
		this.tradeComponent.touchThrough = true;
	}

	/**
	 * 渲染UI时调用
	 */
	protected render(): void {
		this.musicToggle.selected = AudiosMgr.instance.bgmAllow;
	}

	//TODO render gameInfo
	renderGameInfo(gameInfo: pb_11_play.pbGame): void {
		console.log('gameInfo:', gameInfo);
		let {state} = gameInfo;

		if (state == 1) {
			this.renderGameStart(gameInfo);
		}
		else if (state == 2) {
			this.renderGameBet(gameInfo);
		}
	}

	//TODO render gamestart
	renderGameStart(gameInfo: pb_11_play.pbGame): void {
		AlertMgr.instance.showAlert('游戏开始');

		this.setBetGroupEnable(true);
		this.setWinGroupVisible(false);
		this.setCardGroupVisible(false);
		this.myCountText.text = this.dealerCountText.text = '';
		setTimeout(() => {
			let {time, seed} = gameInfo;

			this.clockText.text = time.toString();

			this.clockTimer = setInterval(() => {
				time--;
				this.clockText.text = time.toString();
				if (time == 0) {
					console.log('clock stop');
					clearInterval(this.clockTimer);
				}
			}, 1000)
		}, 2000);

		Bet.instance.renderGameStart();
	}
	//TODO render gameBet
	renderGameBet(gameInfo: pb_11_play.pbGame): void {

	}

	//TODO render lotteryInfo
	async renderLotteryInfo(lotteryInfo: pb_11_play.pbLottery) {
		console.log('lotteryInfo:', lotteryInfo);

		this.setBetGroupEnable(false);

		clearInterval(this.clockTimer);

		let {player, banker, result, playerPair, bankerPair} = lotteryInfo;

		let {Index} = Lang.instance.lang();

		AlertMgr.instance.showAlert(Index.rewarding);
		this.myCountText.text = (player.reduce((prev, cur) => { return prev + this.toPoker(cur) }, 0) % 10).toString();
		this.dealerCountText.text = (banker.reduce((prev, cur) => { return prev + this.toPoker(cur) }, 0) % 10).toString();

		this.clockText.text = Index.rewarding;

		Bet.instance.renderLotteryInfo();

		await this.showLotteryPoker(player, banker);

		this.showLotteryResult(result, bankerPair, playerPair);
	}

	setBetGroupEnable(enable: boolean): void {
		this.betArr.forEach(ele => { ele.touchEnabled = ele.touchChildren = enable; });
	}

	setCardGroupVisible(visible: boolean): void {
		this.myCardArr.forEach(ele => { ele.visible = visible });
		this.dealerCardArr.forEach(ele => { ele.visible = visible });
	}

	setWinGroupVisible(visible: boolean): void {
		this.winArr.forEach(ele => { ele.visible = visible });
	}

	async showLotteryPoker(player: number[], banker: number[]) {
		for (let i = 0, len = Math.max(player.length, banker.length); i < len; i++) {
			await this.showPoker(this.myCardArr[i], player[i]);
			await this.showPoker(this.dealerCardArr[i], banker[i]);
		}
	}

	showLotteryResult(result: string, bankerPair: boolean, playerPair: boolean): void {
		this.setWinGroupVisible(false);

		this.betDealerDoubleWinImg.visible = bankerPair;
		this.betMyDoubleWinImg.visible = playerPair;

		this.betMyWinImg.visible = result === 'player';
		this.betDrawWinImg.visible = result === 'tie';
		this.betDealerWinImg.visible = result === 'banker';
	}

	showPoker(element: eui.Image, value: number): Promise<Object> {
		if (!value) return null;
		return new Promise((resovle, reject) => {
			element.visible = true;
			let imgUrl = `poker_${this.toPoker(value)}_${this.toPokerColour(value)}`;
			element.source = imgUrl;
			setTimeout(function () {
				resovle();
			}, 500);
		})
	}

	setMusicToggle(selected: boolean): void {
		console.log('musicToggle:', selected);
		this.musicToggle.selected = selected;
	}

	//TODO music control
	private onMusicToggle(ev: eui.UIEvent): void {
		console.log('onMusicToggle:', this.musicToggle.selected);
		AudiosMgr.instance.setBgmAllow(this.musicToggle.selected);
		if (this.musicToggle.selected) {
			AudiosMgr.instance.playBgm();
		} else {
			AudiosMgr.instance.stopBgm();
		}
	}

	private onTradeBtn(ev: egret.TouchEvent): void {
		AudiosMgr.instance.playButtonClick();

		Trade.instance.openTradeView();
	}

	//RateBtn-h5
	private onRateBtn(ev: egret.TouchEvent): void {
		AudiosMgr.instance.playButtonClick();
		Rate.instance.openRateView();
	}

	private toPokerColour(poker: number): number {
		return Math.ceil(poker / 13)
	}

	private toPoker(poker: number): number {
		return ((poker - 1) % 13) + 1;
	}


	/**
	 * 改变语言时调用
	 */
	protected onLangChange(ev?: egret.Event): void {
		let {Index, Bet } = Lang.instance.lang();

		this.onlineNumber.text = Index.online + '：55';
		this.dealerIdentityText.text = Bet.banker.toUpperCase();//庄
		this.myIdentityText.text = Bet.player.toUpperCase();//闲
		this.betMyWinText.text = Index.playerWin.toUpperCase() + '\n1:1';//閒赢1 : 1
		this.betDealerWinText.text = Index.bankerWin.toUpperCase() + '\n1:0.95';//莊赢1 : 0.95
		this.betMyDoubleText.text = Bet.bankerPair.toUpperCase() + '\n1:11';//閒對1:11
		this.betDrawText.text = Bet.tie.toUpperCase() + '\n1:11';//和1:11
		this.betDealerDoubleText.text = Bet.bankerPair.toUpperCase() + '\n1:11';//莊對1:11

		if (GAME_ISMOBILE) {
			this.rateBtn.label = Index.rateBtnText;
			this.tradeBtn.label = Index.tradeBtnText;
		}
	}

	private addComponent(target: egret.DisplayObjectContainer, component: UIBaseComponent): void {
		target.addChild(component);
	}

	/**
	 * 下注区域事件
	 */
	private onChipBtn(ev: egret.TouchEvent): void {
		AudiosMgr.instance.playButtonClick();

		if (Bet.instance.chipValue == 0) {
			console.log('请选择筹码');
			return;
		} else {
			if (UserMgr.instance.isLogin()) {
				// console.log(ev.stageX, ev.stageY);
				Bet.instance.largeChipIn(this.chipComponent, ev.stageX, ev.stageY);
			}
		}
	}

	/**
	 * 界面关闭时调用
	 */
	public onClose(): void {
	}
}