class UI_Rate extends UIBaseComponent {
	private bgOpen: eui.Image;
	private bgClose: eui.Image;
	private rateTitle: eui.Label;
	private typeGroup: eui.DataGroup;
	private rateScroller: eui.Scroller;
	private rateList: eui.DataGroup;
	private btnClose: eui.Button;
	private btnOpen: eui.Button;
	private sbtnClose: eui.Button;

	private isOpen: boolean = true;//视图状态-默认打开

	public constructor() {
		super();
	}

	/**
	 * 绑定事件
	 */
	protected bindEvents(): void {
		super.bindEvents();

		mouse.setButtonMode(this.btnClose, true);
		mouse.setButtonMode(this.btnOpen, true);

		this.btnClose.addEventListener(egret.TouchEvent.TOUCH_TAP, this.changeViewStatus, this);
		this.btnOpen.addEventListener(egret.TouchEvent.TOUCH_TAP, this.changeViewStatus, this);
		this.sbtnClose.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onSbtnClose, this);
	}

	/**
	 * 创建完成时调用
	 */
	protected onCreate(): void {
		super.onCreate();
		this.render();
		this.onLangChange();
	}

	//切换视图状态
	private changeViewStatus() {
		this.isOpen = !this.isOpen;

		this.bgOpen.visible = this.isOpen;
		this.rateScroller.visible = this.isOpen;
		this.btnClose.visible = this.isOpen;

		this.bgClose.visible = !this.isOpen;
		this.btnOpen.visible = !this.isOpen;
	}

	private onSbtnClose(){
		Rate.instance.closeRateView();
	}

	/**
	 * 渲染UI时调用
	 */
	protected render(): void {

		this.typeGroup.itemRenderer = UI_RateTypeItem;
		this.typeGroup.dataProvider = new eui.ArrayCollection();

		(this.rateScroller.horizontalScrollBar.thumb as eui.Image ).source= "pc_json.pc_board10";
		this.rateList.itemRenderer = UI_RateItem;
		this.rateList.dataProvider = new eui.ArrayCollection();

		let lang = Lang.instance.lang();
		let rateTypes = [
			{"name":lang.Rate.banker,"count" : 22},
			{"name":lang.Rate.player,"count" : 22},
			{"name":lang.Rate.tie,"count" : 22},
			{"name":lang.Rate.bankerPair,"count" : 22},
			{"name":lang.Rate.playerPair,"count" : 22}
		];

		(this.typeGroup.dataProvider as eui.ArrayCollection).source = rateTypes

		let rateArr = [];
		for (let i = 0; i < 50; i++) {
			let obj = [];
			rateArr.push(obj)
		}

		(this.rateList.dataProvider as eui.ArrayCollection).source = rateArr;
	}


	/**
	 * 改变语言时调用
	 */
	protected onLangChange(ev?: egret.Event): void {
		let lang = Lang.instance.lang();
		let rateTypes = [
			{"name":lang.Rate.banker,"count" : 22},
			{"name":lang.Rate.player,"count" : 22},
			{"name":lang.Rate.tie,"count" : 22},
			{"name":lang.Rate.bankerPair,"count" : 22},
			{"name":lang.Rate.playerPair,"count" : 22}
		]

		this.rateTitle.text = lang.Rate.title;
		(this.typeGroup.dataProvider as eui.ArrayCollection).source = rateTypes;
	}

	/**
	 * 界面关闭时调用
	 */
	public onClose(): void {
	}
}