class UI_UserHeader extends UIBaseComponent {
	private eosText: eui.Label;
	private gtText: eui.Label;
	private eosSurplusText: eui.Label;
	private eosSurplusLangText: eui.Label;
	private btnGtQuestion: eui.Button;
	private btnEosQuestion: eui.Button;
	private btnWithdraw: eui.Button;
	private btnFair: eui.Button;
	public constructor() {
		super();
	}

	/**
	 * 绑定事件
	 */
	protected bindEvents(): void {
		super.bindEvents();
		mouse.setButtonMode(this.btnWithdraw, true);
		mouse.setButtonMode(this.btnFair, true);
		mouse.setButtonMode(this.btnGtQuestion, true);
		mouse.setButtonMode(this.btnEosQuestion, true);
		this.btnWithdraw.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onBtnWithdraw, this);

	}

	/**
	 * 创建完成时调用
	 */
	protected onCreate(): void {
		super.onCreate();
		this.render();
		this.onLangChange();
		if (GAME_ISMOBILE) {
			// this.btnWithdraw.width = 80;//BUG来的 不设置宽度不会跟随皮肤更新
			this.btnFair.parent.addChildAt(this.btnFair, 0);
		}
	}

	/**
	 * 渲染UI时调用
	 */
	protected render(): void {

	}

	/**
	 * 改变语言时调用
	 */
	protected onLangChange(ev?: egret.Event): void {
		let lang = Lang.instance.lang();

		this.eosSurplusLangText.text = lang.Userinfo.eosSurplus;
		this.btnWithdraw.label = lang.Userinfo.withdraw;
		this.btnFair.label = lang.Userinfo.fair;
		this.btnWithdraw.width = (GAME_ISMOBILE ? 40 : 23) + this.btnWithdraw.labelDisplay['width'];
	}
	//TODO user withdraw
	private onBtnWithdraw(ev: egret.TouchEvent): void {
		AudiosMgr.instance.playButtonClick();

		if (UserMgr.instance.isLogin()) {
			console.log('withdraw');
		}
	}
	/**
	 * 界面关闭时调用
	 */
	public onClose(): void {
	}
}